<?php 
  


   //tp - tiny php library
   //(c) 2010 Konstantin Kirillov
   //license - MIT
   //questions? - b e a v e r s c r i p t @ l a n d k e y . n e t

   //Name pollution: only "Tp" is added to global namespace.

   //For making initall settings, skip following header and go to fragment markered with:  //Settings:


       //Enable for debug:
       error_reporting(E_ALL);
       ////ini_set('display_errors','On');
       ini_set('display_errors','1');


class tp_uploader_namespacepolluter4();
{


  const IMG_VALIDATED = 0;
  const IMG_MISSED = 1;
  const IMG_INVALID = 2;
  const IMG_UNSUPPORTED = 3;
  //Set them here when added to the code:
  const SUPPORTED_UPLOAD_EXTENSIONS = 'jpeg|jpg|png|gif';


  //Scans through supported extensions and find out which exist for given file name stub:
  //Returns extension if exists, '' if not.
  public static function find_existing_file_extension($path_stub){
     $extensions = explode( '|', Tp::SUPPORTED_UPLOAD_EXTENSIONS );
     foreach( $extensions as $k => $v ){
       if( file_exists("$path_stub.$v") ){
           return $v;
       }
     }
     return ''; 
  }

  //Scans through supported extensions and find out which exist for given file name stub:
  //Returns extension if exists, '' if not.
  public static function delete_file_by_base_name($path_stub){
     $extensions = explode( '|', Tp::SUPPORTED_UPLOAD_EXTENSIONS );
     $result = true;
     foreach( $extensions as $k => $v ){
       $full_name = "$path_stub.$v";
       if( file_exists($full_name) ){
           $result = $result && unlink( $full_name );
           //echo $full_name . " Result $result ";
       }
     }
     return $result; 
  }


  public static function validate_image( $path, $destroy_image = true ){
       $p = $path;
       $a = array();
       $a[0] = ''; //No exceptions.
       $a[1] = Tp::IMG_VALIDATED;
       if( !file_exists($p) ){
           $a[0] = "Missed image file $p";
           $a[1] = Tp::IMG_MISSED;
           return $a;
       }

       $w = pathinfo( $p ); //TODOm slow.
       $w = strtolower($w['extension']);
       $flag = '';
       $exception = '';
       try { //TODO redundant?
         switch ($w) {
           case 'jpeg':
           case 'jpg':
                 $flag = 'jpg';
                 $im = imagecreatefromjpeg($p);
                 break;
           case 'png':
                 $flag = 'png';
                 $im = imagecreatefrompng($p);
                 break;
           case 'gif':
                 $flag = 'gif';
                 $im = imagecreatefromjgif($p);
                 break;
           default: 
                $a[0] = "Image type not supported.";
                $a[1] = Tp::IMG_UNSUPPORTED;
                return $a;
         }
       }catch (Exception $e) {
            $exception = "\n" . $e->get_message();
       }

       if( $exception != '' or $im == FALSE  ){
           $a[0] = "Unable to interpret image contents.$exception";
           $a[1] = Tp::IMG_INVALID;
           return $a;
       }

       if( $destroy_image ){
           imagedestroy($im);
       }else{
           $a[2] = $flag;
           $a[3] = $im; 
           $a[4] = $path; //debug
       } 
       return $a;

  }


  //Be careful in with $reveal_message.
  //It may reveal secet directories and names in secure environment.
  public static function send_image_from_file( $path, $reveal_message = false ){
       $a = Tp::validate_image($path, false);
       if( $a[0] != '' ){
          header('Content-type: text/plain');
          echo "Image missed.";
          if( $reveal_message ) echo $a[0];
          //if( Tp::IMG_INVALID == $a[1] ) echo "Please send only valid images ...";
          exit();
       }else{
          //header('Content-type: text/plain');
          //print_r( $a  );
          //exit();
       }
       switch ($a[2]){
          case 'jpg':
                header('Content-type: image/jpeg');
                imagejpeg($a[3]);
                break;
          case 'png':
                header('Content-type: image/png');
                imagepng($a[3]);
                break;
          case 'gif':
                header('Content-type: image/gif');
                imagejpeg($a[3]);
                break;
       }
       // Free up memory
       imagedestroy($a[3]);
       exit();
  }


  

  public static function do_upload($storage_path_from_document_root, $file_name_prefix ){
  
     $r = array();     
     $r[0]=''; //Success.
     if( !isset($_FILES['image'])  ){
         $r[0] = "File is not submitted to the server.";
         return $r;
     }

     if(  $_FILES['image']['error'] !== UPLOAD_ERR_OK   ){
         $r[0] = "Upload is failed. Error code is: ". $_FILES['image']['error'];
         return $r;
     }

     //Restrictions by information from the Web client:
     if( !isset($_FILES['image']['size']) || intval($_FILES['image']['size']) == 0 ){
         $r[0] = "Upload is cancelled. File size is not supplied from browser form.";
         return $r;
     }
     $file_size = intval($_FILES['image']['size']);
     if( $file_size > UPLOAD_SIZE_LIMIT ){
         $r[0] = "Upload is cancelled. File size is must not exceed " . UPLOAD_SIZE_LIMIT . '.';
         return $r;
     }

     $file_type = $_FILES['image']['type'];
     $r[2] = $file_size;
     $r[3] = $file_type;
     $r[4] = $_FILES['image']['name'];


     $original_name = basename($_FILES['image']['name']);
     $w = pathinfo( $original_name );
     if( !isset($w['extension'] )){
         $r[0] = "Missed file extension. File name = $original_name.";
         return $r;
     }
     $w = strtolower($w['extension']);

     $r[1]=$w;
     if( !preg_match( '/' . Tp::SUPPORTED_UPLOAD_EXTENSIONS . '/', $w ) ){
         $r[0] = "Invalid file format or extension. File name = $original_name.";
         return $r;
     }

     $file_stub = rtrim( $_SERVER["DOCUMENT_ROOT"], '\/' ) . '/' . $storage_path_from_document_root . '/' . $file_name_prefix;
     deb(" UPLOAD FILE STAB ***************** $file_stub "); 
     $result = Tp::delete_file_by_base_name($file_stub);
     if( !$result  ){
         $r[0] = "Not able to delete former versions of images. Upload cancelled.";
         return $r;
     }

     $fileto = $file_stub . ".$w";
     $from = $_FILES['image']['tmp_name'];
     if( !move_uploaded_file($from,  $fileto)) {
         $r[0] = 'Unable to move uploaded file to storage directory.';
     }
     return $r;

  } 



}
 
tp::addin('uploader');

?>
