<?php

		//******************************************************************************************
		//Plugin:			Utilities
		//To core package:	tp - tiny php library
		//Copyright:		(c) 2010-1011 Konstantin Kirillov
		//License:			MIT
		//******************************************************************************************


		//For case of debugging, do enable following lines:
		//error_reporting(E_ALL);
		//ini_set('display_errors','1');




//================================
// Utilities Class
//================================
 class tp_util_namespacepolluter10
{


	//=======================================================
	//Purpose:  escape double quotes
	//=======================================================
	function escape_dq($s)
	{
		return str_replace("\"", '\"', str_replace("\\", "\\\\", $s));
	}


	//=======================================================
	//Purpose:  converts array to json
	//Input:	$ar - does not contain objects
	//Action:	all array converted to js (jsoned-)objects.
	//=======================================================
	function assarray2json($ar,$indent="\t",$nice="\n")
	{
		$r='';
		$nicer="$nice"."$indent";
		foreach($ar as $k => $v)
		{
			if($r!='')$r.=',';
			$r.="$nicer\"$k\" : ";
			if(is_array($v))
			{	$r .= $this->assarray2json($v, ($indent ? $indent."\t" : ''), $nice );
			}elseif(is_bool($v))
			{
				$r .= $v ? 'true' : 'false';
			}elseif(is_float($v) or is_int($v))
			{
				$r .= "$v ";
			}else{
				$r .= "\"".$this->string2json($v)."\"";
			}
		}
		$r='{'.$r."$nicer}";
		//if($indent=='') $r="$r";
		return $r;
	}



	//=========================================================================================
	//Purpose:  converts array to json
	//Input:	$ar - does not contain objects in its tree.
	//			Non associative (sub)arrays must have non-negative keys.
	//			Integer-indiced arrays can be sparce, in which case gaps can be 
	//			filled with $fill_gabs_in_sparce_array_with_this if non-FALSE.
	//			$object_flag, if set, makes array an object if $object_flag is met as index.
	//			If object_flag index is detected on subarray level, this level is encoded
	//			as object.
	//			further, if value on this index is 'objectsbelow', all following sub-layers
	//			are encoded as objects.
	//Returns:	empty array returns "[]".
	//=========================================================================================
	function array2json(	$ar,$indent="\t",$nice="\n",$debugdebug=false,
							$fill_gabs_in_sparce_array_with_this=FALSE,$object_flag=FALSE)
	{
		//if($debugdebug)deb('arrived linear arr=');
		//if($debugdebug)debob($ar);
		$r='';
		$nicer="$nice"."$indent";
		$next_indent	=	$indent	?	$indent."\t"	:	'';
	
		$is_associative	=	$object_flag && array_key_exists($object_flag,$ar) ? TRUE : FALSE;
		$ass_detected	=	$is_associative;
		if(!$is_associative)
		{
			$max_key1=$this->is_integer_indexed_array($ar);
			if(!$max_key1)$is_associative=TRUE;
		}

		if($is_associative)
		{
			//deb('Process associative array:');
			foreach($ar as $i => $v)
			{		
				if($i===$object_flag)continue;
				if($r!='')$r.=',';
				$r.=$nicer."\"$i\" : ";
				if(is_array($v))
				{	
					//deb('$v is an array. processing it');
					//if($ass_detected )deb("ass below at i=$i, v=$v value of index=".$ar[$object_flag]);
					if($ass_detected && $ar[$object_flag]==='objectsbelow')
					{
						//deb("ass below at i=$i, v=".$v);
						$r .= $this->assarray2json($v,$next_indent,$nice);
					}else{
						//deb("normal below at i=$i, v=".$v);
						$r .= $this->array2json($v,$next_indent,$nice,$debugdebug,$fill_gabs_in_sparce_array_with_this,$object_flag);
					}
				}elseif(is_bool($v))
				{
					$r .= ($v ? 'true' : 'false');
				}elseif(is_float($v) or is_int($v))
				{
					$r .= "$v ";
				}else{
					$r .= "\"".$this->string2json($v)."\"";
				}
			}
			$r="{".$r."$nicer"."}";
			//TODm it seems better to use return by reference &, but there is no confidence this won't kill local variable in PHP:
			//This is a typical for PHP design, no documentation, but forum and hacks in blogs. What is a cow path?:
			//http://www.php.net/manual/en/language.references.return.php
			return $r;
		}

		//Process integer-keyed array:
		for($i=0; $i<$max_key1; $i++)
		{	
			//protector:
			if(array_key_exists($i,$ar))
			{
				$v=$ar[$i];
			}else{
				//We have sparce array:
				if($fill_gabs_in_sparce_array_with_this!==FALSE)
				{
					$v= $fill_gabs_in_sparce_array_with_this;
				}else{
					continue;
				}
			}
			if($r!='')$r.=',';
			$r.=$nicer;
			if(is_array($v))
			{
				$r .= $this->array2json($v,$next_indent,$nice,$debugdebug=false,$fill_gabs_in_sparce_array_with_this,$object_flag);
			}elseif(is_bool($v))
			{
				$r .= $v ? 'true' : 'false';
			}elseif(is_float($v) or is_int($v))
			{
				$r .= "$v ";
			}else{
				$r .= "\"".$this->string2json($v)."\"";
			}
		}
		$r="[$r"."$nicer]";
		return $r;
	}


	//=========================================================================================
	// Purpose: do check is and array based on integer index
	// Returns:	0 if non-integer index is found.
	//			overwise returns (max+1):
	// Input:	can be a sparce array.
	// TODm:		ineffective:
	//=========================================================================================
	function is_integer_indexed_array($arr)
	{
		$max=1;
		foreach($arr as $k=>$v)
		{
			if(!is_int($k))return 0;
			if($k>=$max)$max=$k+1;
		}
		return $max;
	}


	//=========================================================================================
	//Purpose:  eEscape \,\n,\r,":
	//=========================================================================================
	function string2json($s)
	{
		return 
			str_replace("\"", "\\\"", str_replace("\r", "\\r", str_replace("\n", "\\n", str_replace("\\", "\\\\", $s))));
			//faster, but TODOm slashes fail, why?:
			//preg_replace(	array("/\\\\/", "/\\n/", "/\\r/", '/"/'), 
				//			array("\\\\",   "\\\\n", "\\\\r", "\\\\\""),
					//		$s
						//);
	}


	//=========================================================================================
	//Purpose:	get the first token from the string. 
	//Action:		Extract only the first token limited with spacer on the right.
	//TODOm:		separate simple and complex subs:
	//=========================================================================================
	function get_first_token($s){
	     $w = trim($s);
	     $ws = strpos( $w, ' '  );    if( $ws == FALSE ) $ws = strlen($w);
	     $wt = strpos( $w, "\t" );    if( $wt == FALSE ) $wt = strlen($w);
	     $wr = strpos( $w, "\r" );    if( $wr == FALSE ) $wr = strlen($w);
	     $wn = strpos( $w, "\n" );    if( $wn == FALSE ) $wn = strlen($w);
	     $wz = strpos( $w, "\0" );    if( $wz == FALSE ) $wz = strlen($w);
	     $wv = strpos( $w, "\0x0B" ); if( $wv == FALSE ) $wv = strlen($w);
	     $wm = min($ws, $wt, $wr, $wn, $wz, $wv);
	     return substr( $w, 0, $wm );
	}

	//=====================================================================
	//Purpose: do check is the tip of string $s equal to $beginning_token?
	//=====================================================================
	function check_beginning($s,$beginning_token,$case_sensetive=false)
	{  if($case_sensetive) return substr($s,0,strlen($beginning_token)) === $beginning_token;
	   return strtolower(substr($s,0,strlen($beginning_token))) === strtolower($beginning_token);
	}


	//=====================================================================
	//Purpose: join_in_order
	//Note:	join($char,$arr) seems useless for "normal" array:
	//			Let's add this function.
	//Input:	if $length is omitted, then $arr's length is used.
	//=====================================================================
	function join_in_order($char,$arr,$length=-1,$start=0)
	{
	    $joinee='';
	    $len =  $length==-1 ? count($arr) : $length;
	    $len1 = $len-1;
	    for($i=$start; $i<$len; $i++)
	    {
	        if( isset($arr[$i]) ) $joinee .= $arr[$i];
	        if( $i < $len1 ) $joinee .= $char;
	    }
	    return $joinee;
	}


	//=====================================================================
	//Purpose: add days and format:
	//Example: $d1 = add_days( $t, 1 ):
	//=====================================================================
	function add_days( $t, $days ) { return  date("Y-m-d H:i:s", $t + 3600 * 24 * $days ); }



	//=====================================================================
	//Purpose: Add days to timestamp:
	//Example: $d1 = time_add( $t, 1 );
	//=====================================================================
	function add_in_time( $t, $days ) { return  $t + 3600 * 24 * $days;  }
 


	//=====================================================================
	//Purpose: save_file
	//=====================================================================
	function save_file( $name, $data ){
	      $h = fopen( $name, 'w' );
	      fwrite($h, $data );
	      fclose($h);
	}




	////////////////////////////////////////////////////////
	// Message outputters
	//======================================================
	//Purpose: wrap plain message into html page
	//======================================================
	function wrap_to_html( $s,$title='Message' )
	{
		return '<html><head><title>T</title></head><body><pre>' . 
	           htmlspecialchars($s) .
	           "</pre></body></html>";
	}

	//======================================================
	//Purpose: If $r['failure'] exists, then do report and exit:
	//======================================================
	function exithtml($r,$wrap_to_html=true)
	{
		if(!$r || !array_key_exists('failure',$r) || $r['failure']==='')return $r;

		$res=$r['failure'];
		if($r['log']!=='')$res.="\n\nLog:\n".$r['log'];

		if($wrap_to_html)
		{
			echo $this->wrap_to_html($res,'Error');
		}else{
			echo $res;
		}
		exit();
	}

	//===========================================================
	//Purpose: Exit on non empty string with echoing this string
	//===========================================================
	function exiton($s)
	{
		if($s=='')return;
		echo $s;
		exit();
	}
	//======================================================
	// Message outputters
	////////////////////////////////////////////////////////
  


    //======================================================
	//Purpose: Concatenate arrays. Result is in $a.
    //======================================================
	function arrcat(&$a,&$b) { foreach($b as $v) {$a[]=$v;} }	


	//========================================================
	//Purpose:	Convert list of file paths to 
	//			java script and css external links.
	//Input:	$list - file path must be on own line
	//			paths beginning with // or <!-- are comments
	//========================================================
	function list2links($list,$start,$end,$style_start,$style_end,$query_delimiter)
	{
		$list=explode("\n",$list);
		foreach($list as $v)
		{
			$tv			=trim($v);
			if($tv==='' || substr($tv,0,2)==='//')continue;
			if(substr($tv,0,4)==='<!--')
			{
				echo $v."\n";
				continue;
			}

			$av			=explode('.',$tv);
			$last_index	=count($av)-1;
			$type		=$av[$last_index];

			if($type==='js')
			{
				echo $start.$tv.$query_delimiter.$end;
			}elseif($type==='css'){
				echo $style_start.$tv.$query_delimiter.$style_end;
			}
		}
	}


	//================================================================================================
	//Purpose:		Simple uncamelizing: HTML -> h_t_m_l.
	//More on this: http://stackoverflow.com/questions/1993721/how-to-convert-camelcase-to-camel-case
	//================================================================================================
	function unCamel($s)
	{
		return strtolower(
			preg_replace('/^_/','',
				preg_replace('/([A-Z])/', '_$1',$s)
			)
		);
		//For smart uncamelizing, do filter /([A-Z])(_)[A-Z]_/, $1$3_  .
	}

	//================================================================================================
	//Purpose:		uncamelizing
	//Input:		$smart=0 - simple style, 1 - complex, 2 - default.
	//================================================================================================
	function unCamel2($s, $smart=2)
	{
		if($smart===2)	return strtolower(	preg_replace('/((^[A-Z]+[^A-Z]*)|(^[^A-Z]+)|([A-Z]*))([A-Z][^A-Z]*)/',	'$1_$5',$s) 	);

		//try ...
		//if($smart===1)	return strtolower(	preg_replace('/((^.[^A-Z]*)|([^A-Z]*))([A-Z]+)/',				'$1_$4',$s)	);
		//,.. and fix:
		if($smart===1)	return strtolower(	preg_replace('/((^[A-Z]+[^A-Z]+)|(^[^A-Z]+)|([^A-Z]))([A-Z]+)/',				'$1_$5',$s)	);

						//return strtolower(	preg_replace('/(^.[^A-Z]*([A-Z]))|([^A-Z]([A-Z]))/',				'::::$0_$1-$2.$3===',$s)	);
						//learn ...			
						//return strtolower(	preg_replace('/((^.)|[^A-Z]*)([A-Z])/',				'::::$0_$1-$2.$3:$4===',$s)	);
						//... and make:
						//return strtolower(	preg_replace('/((^.)|[^A-Z]*)([A-Z])/',				'$1_$3',$s)	);
						//... and fix:
						return strtolower(	preg_replace('/((^.[^A-Z]*)|([^A-Z]*))([A-Z])/',				'$1_$4',$s)	);

	}





	//================================================================================================
	//Purpose:		Sort content of select element array based on text of an option element.
	//				This array format = array( array(value, text), array(value, text), ... ).
	//Usage:		usort($arr, array(tp::$util, 'sort_select_callb'));
	//================================================================================================
	function sort_select_callb($a, $b) {return strcasecmp($a[1],$b[1]);}


}
tp::addin('util');

?>
